Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(revision 7289)
+++ typo3/sysext/install/mod/class.tx_install.php	(working copy)
@@ -1280,18 +1901,63 @@
 			$cleanupType['cache_imagesizes'] = 'Clear cached image sizes only';
 			$cachedImageSizesCounter = intval($GLOBALS['TYPO3_DB']->exec_SELECTcountRows('*', 'cache_imagesizes'));
 		} else {
-			$this->message($headCode,'Table cache_imagesizes does not exist!',"
-				The table cache_imagesizes was not found. Please check your database settings in Basic Configuration and compare your table definition with the Database Analyzer.
-			",2);
+			$this->message($headCode, 'Table cache_imagesizes does not exist!', '
+				<p>
+					The table cache_imagesizes was not found. Please check your
+					database settings in Basic Configuration and compare your
+					table definition with the Database Analyzer.
+				</p>
+			', 2);
 			$cachedImageSizesCounter = 'unknown';
 		}
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'CleanUpManager.html');
+			// Get the template part from the file
+		$template = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+			// Get the subpart for the 'Clean up' dropdown
+		$cleanUpOptionsSubpart = $this->contentObject->getSubpart($template, '###CLEANUPOPTIONS###');
+		$cleanUpOptions = array();
 
-		$content = '<select name="TYPO3_INSTALL[cleanup_type]">'.$this->getSelectorOptions($cleanupType).'</select> ';
-		$form = '<form action="'.$this->action.'" method="post">'.$content.'<input type="submit" value="Execute"></form>';
-		$this->message($headCode,'Statistics','
-			Number cached image sizes: <strong>'.$cachedImageSizesCounter.'</strong><br />
-		'.$form,1);
-
+		foreach ($cleanupType as $cleanUpKey => $cleanUpValue) {
+				// Define the markers content
+			$cleanUpMarkers = array(
+				'value' => htmlspecialchars($cleanUpKey),
+				'data' => htmlspecialchars($cleanUpValue)
+			);
+				// Fill the markers in the subpart
+			$cleanUpOptions[] = $this->contentObject->substituteMarkerArray(
+				$cleanUpOptionsSubpart,
+				$cleanUpMarkers,
+				'###|###',
+				1,
+				1
+			);
+		}
+			// Substitute the subpart for the 'Clean up' dropdown
+		$content = $this->contentObject->substituteSubpart(
+			$template,
+			'###CLEANUPOPTIONS###',
+			implode(chr(10), $cleanUpOptions)
+		);
+			// Define the markers content
+		$markers = array(
+			'numberCached' => 'Number cached image sizes:',
+			'number' => $cachedImageSizesCounter,
+			'action' => $this->action,
+			'cleanUp' => 'Clean up',
+			'execute' => 'Execute'
+		);
+			// Fill the markers
+		$content = $this->contentObject->substituteMarkerArray(
+			$content,
+			$markers,
+			'###|###',
+			1,
+			1
+		);
+			// Add the content to the message array
+		$this->message($headCode, 'Statistics', $content, 1);
+			// Output the page
 		$this->output($this->outputWrapper($this->printAll()));
 	}
 
@@ -1316,69 +1982,160 @@
 	/**
 	 * Creating the form for editing the TYPO3_CONF_VARS options.
 	 *
-	 * @param	[type]		$type: ...
-	 * @return	[type]		...
+	 * @param string $type If get_form, display form, otherwise checks and store in localconf.php
+	 * @return void
 	 */
-	function generateConfigForm($type='')	{
+	function generateConfigForm($type='') {
 		$default_config_content = t3lib_div::getUrl(PATH_t3lib.'config_default.php');
 		$commentArr = $this->getDefaultConfigArrayComments($default_config_content);
 
-		switch($type)	{
+		switch($type) {
 			case 'get_form':
-				reset($GLOBALS['TYPO3_CONF_VARS']);
-				$this->messageFunc_nl2br=0;
-				while(list($k,$va)=each($GLOBALS['TYPO3_CONF_VARS']))	{
+					// Get the template file
+				$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'GenerateConfigForm.html');
+					// Get the template part from the file
+				$template = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+
+				foreach ($GLOBALS['TYPO3_CONF_VARS'] as $k => $va) {
 					$ext='['.$k.']';
 					$this->message($ext, '$TYPO3_CONF_VARS[\''.$k.'\']',$commentArr[0][$k],1);
 
-					while(list($vk,$value)=each($va))	{
+					foreach ($va as $vk => $value) {
+						$textAreaSubpart = '';
+						$booleanSubpart = '';
+						$textLineSubpart = '';
+
 						$description = trim($commentArr[1][$k][$vk]);
 						$isTextarea = preg_match('/^string \(textarea\)/i',$description) ? TRUE : FALSE;
 						$doNotRender = preg_match('/^string \(exclude\)/i', $description) ? TRUE : FALSE;
 
 						if (!is_array($value) && !$doNotRender && ($this->checkForBadString($value) || $isTextarea)) {
 							$k2 = '['.$vk.']';
-							$msg = htmlspecialchars($description).'<br /><br /><em>'.$ext.$k2.' = '.htmlspecialchars(t3lib_div::fixed_lgd_cs($value,60)).'</em><br />';
 
-							if ($isTextarea)	{
-								$form = '<textarea name="TYPO3_INSTALL[extConfig]['.$k.']['.$vk.']" cols="60" rows="5" wrap="off">'.htmlspecialchars($value).'</textarea>';
+							if ($isTextarea) {
+									// Get the subpart for a textarea
+								$textAreaSubpart = $this->contentObject->getSubpart($template, '###TEXTAREA###');
+									// Define the markers content
+								$textAreaMarkers = array(
+									'id' => $k . '-' . $vk,
+									'name' => 'TYPO3_INSTALL[extConfig]['.$k.']['.$vk.']',
+									'value' => $value
+								);
+									// Fill the markers in the subpart
+								$textAreaSubpart = $this->contentObject->substituteMarkerArray(
+									$textAreaSubpart,
+									$textAreaMarkers,
+									'###|###',
+									1,
+									0
+								);
 							} elseif (preg_match('/^boolean/i',$description)) {
-								$form = '<input type="hidden" name="TYPO3_INSTALL[extConfig]['.$k.']['.$vk.']" value="0">';
-								$form.= '<input type="checkbox" name="TYPO3_INSTALL[extConfig]['.$k.']['.$vk.']"'.($value?' checked="checked"':'').' value="'.($value&&strcmp($value,'0')?htmlspecialchars($value):1).'">';
+									// Get the subpart for a checkbox
+								$booleanSubpart = $this->contentObject->getSubpart($template, '###BOOLEAN###');
+									// Define the markers content
+								$booleanMarkers = array(
+									'id' => $k . '-' . $vk,
+									'name' => 'TYPO3_INSTALL[extConfig]['.$k.']['.$vk.']',
+									'value' => $value && strcmp($value, '0') ? $value : 1,
+									'checked' => $value ? 'checked="checked"' : ''
+								);
+									// Fill the markers in the subpart
+								$booleanSubpart = $this->contentObject->substituteMarkerArray(
+									$booleanSubpart,
+									$booleanMarkers,
+									'###|###',
+									1,
+									0
+								);
 							} else {
-								$form = '<input type="text" size="80" name="TYPO3_INSTALL[extConfig][' . $k . '][' . $vk . ']" value="' . htmlspecialchars($value) . '">';
+									// Get the subpart for an input text field
+								$textLineSubpart = $this->contentObject->getSubpart($template, '###TEXTLINE###');
+									// Define the markers content
+								$textLineMarkers = array(
+									'id' => $k . '-' . $vk,
+									'name' => 'TYPO3_INSTALL[extConfig]['.$k.']['.$vk.']',
+									'value' => $value
+								);
+									// Fill the markers in the subpart
+								$textLineSubpart = $this->contentObject->substituteMarkerArray(
+									$textLineSubpart,
+									$textLineMarkers,
+									'###|###',
+									1,
+									0
+								);
 							}
-							$this->message($ext, $k2,$msg.$form);
+								// Substitute the subpart for a textarea
+							$content = $this->contentObject->substituteSubpart(
+								$template,
+								'###TEXTAREA###',
+								$textAreaSubpart
+							);
+								// Substitute the subpart for a checkbox
+							$content = $this->contentObject->substituteSubpart(
+								$content,
+								'###BOOLEAN###',
+								$booleanSubpart
+							);
+								// Substitute the subpart for an input text field
+							$content = $this->contentObject->substituteSubpart(
+								$content,
+								'###TEXTLINE###',
+								$textLineSubpart
+							);
+								// Define the markers content
+							$markers = array(
+								'description' => htmlspecialchars($description),
+								'key' => '[' . $k . '][' . $vk . ']',
+								'label' => htmlspecialchars(t3lib_div::fixed_lgd_cs($value, 40))
+							);
+								// Fill the markers
+							$content = $this->contentObject->substituteMarkerArray(
+								$content,
+								$markers,
+								'###|###',
+								1,
+								1
+							);
+								// Add the content to the message array
+							$this->message($ext, $k2, $content);
 						}
 					}
 				}
 			break;
 			default:
-				if (is_array($this->INSTALL['extConfig']))		{
-					reset($this->INSTALL['extConfig']);
+				if (is_array($this->INSTALL['extConfig'])) {
 					$lines = $this->writeToLocalconf_control();
-					while(list($k,$va)=each($this->INSTALL['extConfig']))	{
-						if (is_array($GLOBALS['TYPO3_CONF_VARS'][$k]))	{
-							while(list($vk,$value)=each($va))	{
-								if (isset($GLOBALS['TYPO3_CONF_VARS'][$k][$vk]))	{
+					foreach ($this->INSTALL['extConfig'] as $k => $va) {
+						if (is_array($GLOBALS['TYPO3_CONF_VARS'][$k])) {
+							foreach ($va as $vk => $value) {
+								if (isset($GLOBALS['TYPO3_CONF_VARS'][$k][$vk])) {
 									$doit=1;
-									if ($k=='BE' && $vk=='installToolPassword')	{
-										if ($value)	{
-											if (isset($_POST['installToolPassword_check']) && (!t3lib_div::_GP('installToolPassword_check') || strcmp(t3lib_div::_GP('installToolPassword_check'),$value)))	{
+									if ($k=='BE' && $vk=='installToolPassword') {
+										if ($value) {
+											if (isset($_POST['installToolPassword_check']) && (!t3lib_div::_GP('installToolPassword_check') || strcmp(t3lib_div::_GP('installToolPassword_check'),$value))) {
 												$doit=0;
-												t3lib_div::debug('ERROR: The two passwords did not match! The password was not changed.');
+												$this->errorMessages[] = '
+													The two passwords did not
+													match! The password was not
+													changed.
+												';
 											}
 											if (t3lib_div::_GP('installToolPassword_md5'))	$value =md5($value);
 										} else $doit=0;
 									}
 
 									$description = trim($commentArr[1][$k][$vk]);
-									if (preg_match('/^string \(textarea\)/i', $description))	{
-										$value = str_replace(chr(13),'',$value);	// Force Unix linebreaks in textareas
-										$value = str_replace(chr(10),"'.chr(10).'",$value);	// Preserve linebreaks
+									if (preg_match('/^string \(textarea\)/i', $description)) {
+											// Force Unix linebreaks in textareas
+										$value = str_replace(chr(13),'',$value);
+											// Preserve linebreaks
+										$value = str_replace(chr(10),"'.chr(10).'",$value);
 									}
 									if (preg_match('/^boolean/i', $description)) {
-											// When submitting settings in the Install Tool, values that default to "false" or "true" in config_default.php will be sent as "0" resp. "1". Therefore, reset the values to their boolean equivalent.
+											// When submitting settings in the Install Tool, values that default to "false" or "true"
+											// in config_default.php will be sent as "0" resp. "1". Therefore, reset the values
+											// to their boolean equivalent.
 										if ($GLOBALS['TYPO3_CONF_VARS'][$k][$vk] === false && $value === '0') {
 											$value = false;
 										} elseif ($GLOBALS['TYPO3_CONF_VARS'][$k][$vk] === true && $value === '1') {
@@ -1398,27 +2155,27 @@
 	}
 
 	/**
-	 * [Describe function...]
+	 * Make an array of the comments in the t3lib/config_default.php file
 	 *
-	 * @param	[type]		$string: ...
-	 * @param	[type]		$mainArray: ...
-	 * @param	[type]		$commentArray: ...
-	 * @return	[type]		...
+	 * @param string $string The contents of the config_default.php file
+	 * @param array $mainArray
+	 * @param array $commentArray
+	 * @return array
 	 */
-	function getDefaultConfigArrayComments($string,$mainArray=array(),$commentArray=array())	{
+	function getDefaultConfigArrayComments($string,$mainArray=array(),$commentArray=array()) {
 		$lines = explode(chr(10),$string);
 		$in=0;
 		$mainKey='';
-		while(list(,$lc)=each($lines))	{
+		foreach ($lines as $lc) {
 			$lc = trim($lc);
 			if ($in) {
-				if (!strcmp($lc,');'))	{
+				if (!strcmp($lc,');')) {
 					$in=0;
 				} else {
-					if (preg_match('/["\']([[:alnum:]_-]*)["\'][[:space:]]*=>(.*)/i',$lc,$reg))	{
+					if (preg_match('/["\']([[:alnum:]_-]*)["\'][[:space:]]*=>(.*)/i',$lc,$reg)) {
 						preg_match('/,[\t\s]*\/\/(.*)/i',$reg[2],$creg);
 						$theComment = trim($creg[1]);
-						if (substr(strtolower(trim($reg[2])),0,5)=='array' && !strcmp($reg[1],strtoupper($reg[1])))	{
+						if (substr(strtolower(trim($reg[2])),0,5)=='array' && !strcmp($reg[1],strtoupper($reg[1]))) {
 							$mainKey=trim($reg[1]);
 							$mainArray[$mainKey]=$theComment;
 						} elseif ($mainKey) {
@@ -1455,9 +2212,9 @@
 	/**
 	 * Checking php.ini configuration and set appropriate messages and flags.
 	 *
-	 * @return	[type]		...
+	 * @return void
 	 */
-	function checkConfiguration()	{
+	function checkConfiguration() {
 		$ext='php.ini configuration checked';
 		$this->message($ext);
 
@@ -1467,74 +2224,137 @@
 
 			// Includepath
 		$incPaths = t3lib_div::trimExplode(TYPO3_OS=='WIN'?';':':', ini_get('include_path'));
-		if (!in_array('.',$incPaths))	{
-			$this->message($ext, 'Current directory (./) is not in include path!',"
-				<i>include_path=".ini_get('include_path')."</i>
-				Normally the current path, '.', is included in the include_path of PHP. Although TYPO3 does not rely on this, it is an unusual setting that may introduce problems for some extensions.
-			",1);
+		if (!in_array('.',$incPaths)) {
+			$this->message($ext, 'Current directory (./) is not in include path!', '
+				<p>
+					<em>include_path=' . ini_get('include_path') . '</em>
+					<br />
+					Normally the current path, \'.\', is included in the
+					include_path of PHP. Although TYPO3 does not rely on this,
+					it is an unusual setting that may introduce problems for
+					some extensions.
+				</p>
+			', 1);
 		} else $this->message($ext, 'Current directory in include path',"",-1);
 
 			// *****************
 			// File uploads
 			// *****************
-		if (!ini_get('file_uploads'))	{
-			$this->message($ext, 'File uploads not allowed',"
-				<i>file_uploads=".ini_get('file_uploads')."</i>
-				TYPO3 uses the ability to upload files from the browser in various cases.
-				As long as this flag is disabled, you'll not be able to upload files.
-				But it doesn't end here, because not only are files not accepted by the server - ALL content in the forms are discarded and therefore nothing at all will be editable if you don't set this flag!
-				However if you cannot enable fileupload for some reason alternatively you change the default form encoding value with \$TYPO3_CONF_VARS[SYS][form_enctype].
-			",3);
+		if (!ini_get('file_uploads')) {
+			$this->message($ext, 'File uploads not allowed', '
+				<p>
+					<em>file_uploads=' . ini_get('file_uploads') . '</em>
+					<br />
+					TYPO3 uses the ability to upload files from the browser in
+					various cases.
+					<br />
+					As long as this flag is disabled, you\'ll not be able to
+					upload files.
+					<br />
+					But it doesn\'t end here, because not only are files not
+					accepted by the server - ALL content in the forms are
+					discarded and therefore nothing at all will be editable
+					if you don\'t set this flag!
+					<br />
+					However if you cannot enable fileupload for some reason
+					alternatively you change the default form encoding value
+					with \$TYPO3_CONF_VARS[SYS][form_enctype].
+				</p>
+			', 3);
 		} else $this->message($ext, 'File uploads allowed',"",-1);
 
-		$upload_max_filesize = $this->convertByteSize(ini_get('upload_max_filesize'));
-		$post_max_size = $this->convertByteSize(ini_get('post_max_size'));
-		if ($upload_max_filesize<1024*1024*10)	{
-			$this->message($ext, 'Maximum upload filesize too small?',"
-				<i>upload_max_filesize=".ini_get('upload_max_filesize')."</i>
-				By default TYPO3 supports uploading, copying and moving files of sizes up to 10MB (You can alter the TYPO3 defaults by the config option TYPO3_CONF_VARS[BE][maxFileSize]).
-				Your current value is below this, so at this point, PHP sets the limits for uploaded filesizes and not TYPO3.
-				<strong>Notice:</strong> The limits for filesizes attached to database records are set in the tables.php configuration files (\$TCA) for each group/file field. You may override these values in localconf.php or by page TSconfig settings.
-			",1);
+		$upload_max_filesize = t3lib_div::getBytesFromSizeMeasurement(ini_get('upload_max_filesize'));
+		$post_max_size = t3lib_div::getBytesFromSizeMeasurement(ini_get('post_max_size'));
+		if ($upload_max_filesize<1024*1024*10) {
+			$this->message($ext, 'Maximum upload filesize too small?', '
+				<p>
+					<em>upload_max_filesize=' . ini_get('upload_max_filesize') . '</em>
+					<br />
+					By default TYPO3 supports uploading, copying and moving
+					files of sizes up to 10MB (You can alter the TYPO3 defaults
+					by the config option TYPO3_CONF_VARS[BE][maxFileSize]).
+					<br />
+					Your current value is below this, so at this point, PHP sets
+					the limits for uploaded filesizes and not TYPO3.
+					<br />
+					<strong>Notice:</strong> The limits for filesizes attached
+					to database records are set in the tables.php configuration
+					files (\$TCA) for each group/file field. You may override
+					these values in localconf.php or by page TSconfig settings.
+				</p>
+			', 1);
 		}
-		if ($upload_max_filesize > $post_max_size)	{
-			$this->message($ext, 'Maximum size for POST requests is smaller than max. upload filesize','
-				<i>upload_max_filesize='.ini_get('upload_max_filesize').', post_max_size='.ini_get('post_max_size').'</i>
-				You have defined a maximum size for file uploads which exceeds the allowed size for POST requests. Therefore the file uploads can not be larger than '.ini_get('post_max_size').'
-			',1);
+		if ($upload_max_filesize > $post_max_size) {
+			$this->message($ext, 'Maximum size for POST requests is smaller than max. upload filesize', '
+				<p>
+					<em>upload_max_filesize=' . ini_get('upload_max_filesize') . '
+					, post_max_size=' . ini_get('post_max_size') . '</em>
+					<br />
+					You have defined a maximum size for file uploads which
+					exceeds the allowed size for POST requests. Therefore the
+					file uploads can not be larger than ' . ini_get('post_max_size') . '
+				</p>
+			', 1);
 		}
 
 			// *****************
 			// Memory and functions
 			// *****************
-		$memory_limit_value = $this->convertByteSize(ini_get('memory_limit'));
+		$memory_limit_value = t3lib_div::getBytesFromSizeMeasurement(ini_get('memory_limit'));
 
 		if ($memory_limit_value && $memory_limit_value < t3lib_div::getBytesFromSizeMeasurement(TYPO3_REQUIREMENTS_MINIMUM_PHP_MEMORY_LIMIT)) {
-			$this->message($ext, 'Memory limit below ' . TYPO3_REQUIREMENTS_MINIMUM_PHP_MEMORY_LIMIT,'
-				<i>memory_limit=' . ini_get('memory_limit') . '</i>
-				Your system is configured to enforce a memory limit of PHP scripts lower than ' . TYPO3_REQUIREMENTS_MINIMUM_PHP_MEMORY_LIMIT . '. The Extension Manager needs to include more PHP-classes than will fit into this memory space. There is nothing else to do than raise the limit. To be safe, ask the system administrator of the webserver to raise the limit to over ' . TYPO3_REQUIREMENTS_MINIMUM_PHP_MEMORY_LIMIT . '.
-			',3);
+			$this->message($ext, 'Memory limit below ' . TYPO3_REQUIREMENTS_MINIMUM_PHP_MEMORY_LIMIT, '
+				<p>
+					<em>memory_limit=' . ini_get('memory_limit') . '</em>
+					<br />
+					Your system is configured to enforce a memory limit of PHP
+					scripts lower than ' . TYPO3_REQUIREMENTS_MINIMUM_PHP_MEMORY_LIMIT . '.
+					The Extension Manager needs to include more PHP-classes than
+					will fit into this memory space. There is nothing else to do
+					than raise the limit. To be safe, ask the system
+					administrator of the webserver to raise the limit to over
+					' . TYPO3_REQUIREMENTS_MINIMUM_PHP_MEMORY_LIMIT . '.
+				</p>
+			', 3);
 		} elseif(!$memory_limit_value) {
-			$this->message($ext, 'Memory limit',"<i>No memory limit in effect.</i>",-1);
-		} else $this->message($ext, 'Memory limit',"<i>memory_limit=".ini_get('memory_limit')."</i>",-1);
-		if (ini_get('max_execution_time')<30)	{
-			$this->message($ext, 'Maximum execution time below 30 seconds',"
-				<i>max_execution_time=".ini_get('max_execution_time')."</i>
-				May impose problems if too low.
-			",1);
+			$this->message($ext, 'Memory limit', '
+				<p>
+					<em>No memory limit in effect.</em>
+				</p>
+			', -1);
 		} else {
-			$this->message($ext, 'Maximum execution time',"<i>max_execution_time=".ini_get('max_execution_time')."</i>",-1);
+			$this->message($ext, 'Memory limit: ' . ini_get('memory_limit'), '', -1);
 		}
-		if (ini_get('disable_functions'))	{
-			$this->message($ext, 'Functions disabled!',"
-				<i>disable_functions=".ini_get('disable_functions')."</i>
-				The above list of functions are disabled. If TYPO3 use any of these there might be trouble.
-				TYPO3 is designed to use the default set of PHP4.3.0+ functions plus the functions of GDLib.
-				Possibly these functions are disabled due to security risks and most likely the list would include a function like <i>exec()</i> which is use by TYPO3 to access ImageMagick.
-			",2);
+		if (ini_get('max_execution_time')<30) {
+			$this->message($ext, 'Maximum execution time below 30 seconds', '
+				<p>
+					<em>max_execution_time=' . ini_get('max_execution_time') . '</em>
+					<br />
+					May impose problems if too low.
+				</p>
+			', 1);
 		} else {
-			$this->message($ext, 'Functions disabled: none',"",-1);
+			$this->message($ext, 'Maximum execution time: ' . ini_get('max_execution_time') . ' seconds', '', -1);
 		}
+		if (ini_get('disable_functions')) {
+			$this->message($ext, 'Functions disabled!', '
+				<p>
+					<em>disable_functions=' . ini_get('disable_functions') . '</em>
+					<br />
+					The above list of functions are disabled. If TYPO3 use any
+					of these there might be trouble.
+					<br />
+					TYPO3 is designed to use the default set of PHP4.3.0+
+					functions plus the functions of GDLib.
+					<br />
+					Possibly these functions are disabled due to security risks
+					and most likely the list would include a function like
+					<em>exec()</em> which is use by TYPO3 to access ImageMagick.
+				</p>
+			', 2);
+		} else {
+			$this->message($ext, 'Functions disabled: none', '', -1);
+		}
 		// Mail tests
 		if (TYPO3_OS == 'WIN') {
 			$smtp = ini_get('SMTP');
